**********************************************************
*                                                        *
*   Conversion d'une image TRANS au format DEFV          *
*   ou a un format lisible par xtrn                      *
*                                                        *
*   Y.E.                            Janvier 1994         *
*                                                        *
*   Ajout du format T3D             Fevrier 1996         *
*                                                        *
*                                                        *
**********************************************************

      integer ir, nx, ny, line, MAXLINE
	  integer j, nxrep,mot
      double precision xn, yn, xnrep
*
*  MAXLINE: longueur maximum d'une ligne d'image
*  MOT: longueur du mot machine (4 ou 8)
*	  
	  parameter (MAXLINE=2048)
	  real tab(MAXLINE)
      double precision xtab(MAXLINE)
	  character image*40, image1*40, titre*80,option*1
*
      write(unit=*,fmt=*)'Convert V2.1 01/95'
      write(*,*) ' '
      Write(*,*) 'Choice of formats for the image'  
*
*      type de conversion
*
      write(*,*) 'type de conversion:'
      write(*,*) 'source: format defv, dest: raw float    - (1)'
      write(*,*) 'source: format transq, dest: defv       - (2)'
      write(*,*) 'source: format transq, dest: raw float  - (3)'
      write(*,*) 'source: format 1979  , dest:raw float   - (4)'
      write(*,*) 'source: T3D (see 3)  , dest:raw float   - (5)'
      write(*,*) 'help:                                   - (?)'
      read(*,'(A)') option
      if (option.eq.'?') then
          call sos
          stop
      endif
      write(unit=*,fmt=*) 'Name of image file to be converted?' 
      read(*,'(A)') image
      write(unit=*,fmt=*) 'Name of image file to create?' 
      read(*,'(A)') image1
*      
      if (option.eq.'2'.or.option.eq.'3') then
         write(*,*) 'Length of word for source? (4/8)'
         read (*,*) mot
         if (mot.eq.4) then
             write(*,*) 'Version 32 byte word'
         else if(mot.eq.8) then
             write(*,*) 'Version 64 byte word'
         else
             write(*,*) 'word length not valid'
            stop 'Error word length'
         endif
      endif                                  
      if(option.eq.'5') then
         mot=8
      endif 
*
*    conversions
*	  
*    option 2:    transq ---> defv
*    option 3,5:  transq ---> octet
*
*    La taille de l'image est inconnue, donc le blksize.
*    On ouvre avec une longueur bidon
*    pour lire le premier enregistrement qui contient cette
*    information
*
      if (option.eq.'2'.or.option.eq.'3'.or.option.eq.'5') then
          open(unit=15,file=image,access='direct',
     &    status='old',recl=80,iostat=ir)
          if(ir.ne.0) then
             write(unit=*,fmt=1000) image,ir
1000      format('Error open file ',A,' code ',I4)
	      stop 'error open image file'
          endif
          if(option.eq.'2'.or.option.eq.'3') then
	          read(unit=15,rec=1) nxrep
          else
              read(unit=15,rec=1) xnrep
              nxrep=xnrep
          endif
	      close(unit=15)     
*
*     Ouverture du fichier image a convertir
*
          open(unit=15,file=image,access='direct',status='old',
     1         recl=max(80,nxrep*MOT),iostat=ir)
    	  if(ir.ne.0) then
    	      write(unit=*,fmt=1000) 'error open ',image,'code ',ir
              stop 'error open image file'
          endif
*
*     Lecture des informations de tete. 
*
          if(option.eq.'2'.or.option.eq.'3') then
              read(unit=15,rec=2) titre
              read(unit=15,rec=3) nx,ny
*
*     Le pb est que la T3D ne connait que la double precision d'ou
*     conversion. La lecture du titre est bidon. Il ne sera pas
*     convertible
*
          else
              titre = 'T3D: titre non convertible'
              read(unit=15,rec=3) xn,yn
              nx = xn
              ny = yn
          endif
      endif
*
*     option 1: defv ---> octet
*
      if (option.eq.'1') then
           open(unit=15,file=image,form='unformatted',status='old',
     &          iostat=ir)
          if (ir.ne.0) then
                write(*,*) 'error open ',image,' code ',ir
                stop 'error open image file'
          endif 
*
*     Lecture des informations de tete. 
* 
          read(unit=15) titre
          read(unit=15) nx,ny
*
*     option 4: def4 ---> octet
*
      else if(option.eq.'4')then
           open(unit=15,file=image,form='unformatted',status='old',
     &          iostat=ir)
          if (ir.ne.0) then
                write(*,*) 'error open ',image,' code ',ir
                stop 'error open image file'
          endif 
          write(*,*) 'length of line and number of lines?'
          read(*,*) nx,ny
          titre=' '
      endif
	  write(unit=*,fmt=1001) titre,nx,ny
1001  format(A/"taille d'image: ",I4," x ", I4)
*
	  if(nx.gt.MAXLINE) then
		  write(unit=*,fmt=*) 'More than ',MAXLINE,' points per line'
		  write(unit=*,fmt=*) 'Recompile the programm changing MAXLINE'
          close(unit=15)
		  stop 'Erreur 1'
      endif
*
*     Ouverture du fichier resultat
*
*     format defv (option 2)
*
      if (option.eq.'2') then
	  open(unit=16,file=image1,form='unformatted',
     1         status='new',iostat=ir)
          if(ir.ne.0) then
              write(*,*) 'error open ',image1, 'code',ir
              stop 'error open destination file'
          endif
      else
*
*     format octet (options 1, 3 et 4)
*      
          open(unit=16,file=image1,access='direct',recl=4*nx,
     &          status='new',iostat=ir)
      endif
          if(ir.ne.0) then
          	  write(*,*)'error file ',image1,'code ',ir
		  close(unit=15)
		  stop 'error destination file'
          endif
* 
*     ecriture image destination
*
      if (option.eq.'2') then   
          write(unit=16)titre
	      write(unit=16)nx,ny
      endif
*      	  
*     Transcription
*
      do line =1, ny
         if (option.eq.'2'.or.option.eq.'3') then  
	          read(unit=15,rec=line+3,iostat=ir) (tab(j),j=1,nx)
         else if(option.eq.'5') then
              read(unit=15,rec=line+3,iostat=ir) (xtab(j),j=1,nx)
              do j = 1,nx
                tab(j)=xtab(j)
              enddo 
	     else
              read(unit=15,iostat=ir) (tab(j),j=1,nx)
         endif     
	     if(ir.ne.0) then
	          write(*,*)'error reading ',image,'code ',ir
		  close(unit=15)
		  close(unit=16)
		  stop 'error reading source'
             endif
          if (option.eq.'2') then 
	          write(unit=16,iostat=ir) (tab(j),j=1,nx)
	      else
	          write(unit=16,rec=line,iostat=ir) (tab(j),j=1,nx) 
	      endif
	      if(ir.ne.0) then
		      write(*,*)'error writing ',image1,' code ',ir
		      close(unit=15)
		      close(unit=16)
		      stop 'error writing '
          endif
	  end do

	  close (unit=15)
	  close (unit=16)
	  stop 'done'
	  end
*
*---------------------------------------------------------------------------
*
       subroutine sos
       write(*,*) 'Conversion program convert'
       write(*,*) '--------------------------'
       write(*,*)
       write(*,*) 'To convert simulated images to various' 
       write(*,*) 'representation formats'
       write(*,*)
       write(*,*) '- 1 - format def.. to raw float'
       write(*,*) '- 2 - format trans. to def..'
       write(*,*) '- 3 - format trans. to raw float'
       write(*,*) '- 4 - format before 1979 to raw float'
       write(*,*) '- 5 - format T3D to raw float'
       write(*,*) 
       write(*,*) 'raw float is an entry format for Triton'
       write(*,*) 'def. format for compatibility only with old' 
       write(*,*) 'representation programs (visim ...). Raw float and'
       write(*,*) 'xtrn are recommanded'
       write(*,*)
       write(*,*) 'option 4 for old programs written before 1979 only.'
       write(*,*)
       write(*,*) 'Programs def.., emp.. use def format, programs' 
       write(*,*) 'trans.. use trans format. Since the images may be' 
       write(*,*) 'computed on Cray computers in IEEE format, the'
       write(*,*) 'word length (4 or 8) must be given.'
       write(*,*)
       write(*,*) 'Other data:'
       write(*,*) '- size of image for option 4'
       write(*,*) '- word size for option 2 and 3'
       write(*,*) '- image source and destination'
       return
       end
